#include <iostream>
#include <sstream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <cstdlib>
#include <limits>
#include <ctime> 

// #include "constants.h"

using std::ifstream;
using std::ofstream;
using std::endl;

using namespace std;

const int fFarms = 6, iActivity = 5, kLineSegment = 2,  pPeriods  = 40, vVessels = 9, wOffshore = 2, sScenario = 10;
//When the amount of vVessels and wOffshore changes, the inputfile also need to change.
// Max fFarms is 13. 
// pPeriods > fFamrs
// NB! Jeg bruker sScenarios i Xpress filen, men sScenario uten s tilslutt her

// void writePV(double PVarray[pPeriods][vVessels]);

int main()
{
	double rate = 0.03;
	double reduction = 0.3;
	int maximumCapacityOffshore = 10;
	int budget0 = 1000000000;
	int LifeTimeOfVessel = 20;
	int LifeTimeOfOffshore = 30;
	int NumberOfPeriodsPerYear = 4;
	int HelpMaintenanceProbability[5] =  {100 , 13 , 27	, 55 , 20}; // given in prosent

	for (int i = 0; i<5; i++)
	{
		HelpMaintenanceProbability[i] = HelpMaintenanceProbability[i]/NumberOfPeriodsPerYear;
		cout << HelpMaintenanceProbability[i] << endl;
	}
	
	ifstream inTime;
	ifstream inEl;
	ifstream inNumber;
	ifstream inTimeIV;
	ifstream inTimeFV;
	ifstream inInvCostV;
	ifstream inInvCostW;
	ifstream inFixCostV;
	ifstream inFixCostW;
	ifstream inVarCost;
	ifstream inRentCost;
	ofstream outStream;

	inInvCostV.open("inInvCostV.txt");
	inInvCostW.open("inInvCostW.txt");
	inFixCostV.open("inFixCostV.txt");
	inFixCostW.open("inFixCostW.txt");
	inVarCost.open("inVarCost.txt");
	inRentCost.open("inRentCost.txt");
	inTimeIV.open("inTimeIV.txt");
	inTimeFV.open("inTimeFV.txt");
	inTime.open("timeIn.txt");
	inEl.open("inElPrice.txt");
	inNumber.open("inMainNumber.txt");
	
	outStream.open("outfile.txt");
	if (outStream.fail())
	{
		cout << "Output file opening failed. \n";
		exit (1);
	}

	outStream << "fFarms : "		<< fFarms		<< endl;
	outStream << "iActivity : "		<< iActivity	<< endl;
	outStream << "kLineSegment : "	<< kLineSegment << endl;
	outStream << "pPeriods : "		<< pPeriods		<< endl;
	outStream << "vVessels : "		<< vVessels		<< endl;
	outStream << "wOffshore : "		<< wOffshore	<< endl;
	outStream << "sScenarios: "		<< sScenario	<< endl << endl;

	double InvCostV[pPeriods][vVessels];
	double FixCostV[pPeriods][vVessels];
	double VarCost[pPeriods][vVessels];
	double RentCost[pPeriods][vVessels];
	double InvCostW[pPeriods][wOffshore];
	double FixCostW[pPeriods][wOffshore];
	double DownCost[fFarms][iActivity][kLineSegment][pPeriods];
	double Budget[pPeriods];
	double SelRevenue[pPeriods][vVessels];
	double HireRevenue[pPeriods][vVessels];
	double OpTime[pPeriods][vVessels][sScenario]; //Stochastic
	double MainTime[fFarms][iActivity][pPeriods][vVessels];
	double MaxCap[wOffshore];
	double AmCap[vVessels][wOffshore];
	double ActNum[fFarms][iActivity][pPeriods][sScenario]; //Stochastic
	double MaxLim[kLineSegment];
	double ResValue[vVessels];
	double Probability[sScenario]; //Stochastic

	int HelpTimeIV[8][9];
	double HelpTimeFV[10][9];
	double HelpElPrice[50][4];
	int HelpOpTime[4][9][100]; // Stochastic
	int HelpNumber[8][4];
	int HelpInvVessel[9];
	int HelpFixVessel[9];
	int HelpInvOffshore[2];
	int HelpFixOffshore[2];
	int HelpVariableCost[9];
	int HelpRentCost[9];
	int HelpWindData[fFarms][4];

	srand((unsigned)time(0)); 
	// int RandomTurbine;
	cout << "HelpWindData: " << endl << "Wind Park Number | Number Of Wind Turbine | Distance to land | Open in time period " << endl;
	for (int f=0; f<fFarms; f++)
	{	
		HelpWindData[f][0] = f+1;
		cout << HelpWindData[f][0] << "		";
		// RandomTurbine = (rand()%10)+1;
		// HelpWindData[f][1] = RandomTurbine*10;
		// HelpWindData[f][1] = 40 + (10*f);
		 HelpWindData[f][1] = 200;
		cout << HelpWindData[f][1] << "		";
		// HelpWindData[f][2] = 130 - (10*f);
		HelpWindData[f][2] = 150 ;
		cout << HelpWindData[f][2] << "		";
		HelpWindData[f][3] = 4*(f+1)-3;
		// HelpWindData[f][3] = 1;
		cout << HelpWindData[f][3] << endl ;
	}


	// The cost read in here is the cost per year. This costs need to be changed.
	for (int v=0; v<9; v++)
	{
		inInvCostV >> HelpInvVessel[v];
		inFixCostV >> HelpFixVessel[v];
		inVarCost >> HelpVariableCost[v];
		inRentCost >> HelpRentCost[v];
	}

	for (int w=0; w<2; w++)
	{
		inInvCostW >> HelpInvOffshore[w];
		inFixCostW >> HelpFixOffshore[w];
	}
	cout << "HelpTimeIV: " << endl;
	for (int x=0; x<8; x++)
	{
		for (int y=0; y<9; y++)
		{
			inTimeIV >> HelpTimeIV[x][y];
			cout << HelpTimeIV[x][y] << "	";
		}
		cout << endl;
	}

	cout << "HelpTimeFV: " << endl;
	for (int x=0; x<10; x++)
	{
		for (int y=0; y<9; y++)
		{
			inTimeFV >> HelpTimeFV[x][y];
			cout << HelpTimeFV[x][y] << "	";
		}
		cout << endl;
	}

	cout << "HelpNumber: " << endl;
	for (int x=0; x<8; x++)
	{
		for (int y=0; y<4; y++)
		{
			inNumber >> HelpNumber[x][y];
			cout << HelpNumber[x][y] << "	";
		}
		cout << endl;
	}

	cout << "HelpElPrice: " << endl;
	for (int x=0; x<50; x++)
	{
		for (int y=0; y<4; y++)
		{
			inEl >> HelpElPrice[x][y];
			cout << HelpElPrice[x][y] << "	";
		}
		cout << endl;
	}

	cout << "HelpOpTime: " << endl;
	for (int x=0; x<4; x++)
	{
		for (int y=0; y<9; y++)
		{
			for (int z=0; z<100; z++)
			{
				inTime >> HelpOpTime[x][y][z];
				// cout << HelpOpTime[x][y][z] << "	";
			}
			cout << endl;
		}
		cout << endl;
	}

	//Reading first column in InvCostV
	cout << "InvCostV: " << endl;
	for (int v=0; v<vVessels; v++)
	{
		InvCostV[0][v] = HelpInvVessel[v] * LifeTimeOfVessel;
		cout << InvCostV[0][v] << endl;
	}

	//SelRevenue is a part of the investment cost
	for (int v=0; v<vVessels; v++)
	{
		SelRevenue[0][v] = InvCostV[0][v] * reduction;
	}

	//Reading first column in InvCostW
	for (int w=0; w<wOffshore; w++)
	{
		InvCostW[0][w] = HelpInvOffshore[w] * LifeTimeOfOffshore;
	}
	 //Reading first column in FixCostV
	for (int v=0; v<vVessels; v++)
	{
		FixCostV[0][v] = HelpFixVessel[v] / NumberOfPeriodsPerYear;
	}

	//Reading first column in FixCostW
	for (int w=0; w<wOffshore; w++)
	{
		FixCostW[0][w] = HelpFixOffshore[w] / NumberOfPeriodsPerYear;
	}

	//Reading first column in VarCost
	for (int v=0; v<vVessels; v++)
	{
		VarCost[0][v] = HelpVariableCost[v];
	}

	//Reading first column in RentCost
	for (int v=0; v<vVessels; v++)
	{
		RentCost[0][v] = HelpRentCost[v] / NumberOfPeriodsPerYear;
	}

	//Hire Revenue 
	for (int v=0; v<vVessels; v++)
	{
		HireRevenue[0][v] = HelpInvVessel[v] / (pPeriods + 2);
	}
	
	//Reading budget limit
	Budget[0] = budget0;

	//MaxCap
	for (int w=0; w<wOffshore; w++)
	{
		MaxCap[w]= maximumCapacityOffshore*(1+w);
	}

	//AmCap
	for ( int v=0; v<vVessels; v++)
	{
		for (int w=0; w<wOffshore; w++)
		{
			if(v==0)
				AmCap[v][w]=0.25;
			else if(v==6)
				AmCap[v][w]=0.5;
			else
				AmCap[v][w]=0;
		}
	}
	
	//MaxLim
	for (int k=0; k<kLineSegment; k++)
	{
		MaxLim[k]= (1+k)*2;
	}

	//OpTime
	int pp;
	for (int p=0; p<pPeriods; p++)
	{
		pp=p%4;
		for (int v=0; v<vVessels; v++)
		{
			for (int s=0; s<sScenario;s++)
			{
				OpTime[p][v][s]=HelpOpTime[pp][v][s];
			}
		}
		cout << pp << "	";
	}

	//DownCost
	for (int f=0; f<fFarms; f++)
	{
		for (int i=0; i<iActivity; i++)
		{
			for (int k=0; k<kLineSegment; k++)
			{
				for (int p=0; p<pPeriods; p++)
				{
					pp=p%4;
					DownCost[f][i][k][p]=HelpElPrice[f][pp]/(1+k);
					
				}
			}
		}
	}
	
	int numberOfTurbines;
	int NumberOfMaintenanceTask;
	int randomInteger;


	//////// Endres til stokastisk modell. 
	//ActNum
	for (int f=0; f<fFarms; f++)
	{
		numberOfTurbines = HelpWindData[f][1];
		for (int i=0; i<iActivity; i++)
		{
			for (int p=0; p<pPeriods; p++)
			{
				pp=p%4;
				for (int s=0; s<sScenario; s++)
				{
					if (HelpWindData[f][3] > p)
					{
						ActNum[f][i][p][s] = 0;
					}
					else if ( (i==0) && ((pp==0) || (pp==3)) )
					{
						ActNum[f][i][p][s] = 0;
					}
					else if ( (i==0) )
					{
						ActNum[f][i][p][s] = numberOfTurbines;
					}
					else
					{
						NumberOfMaintenanceTask = 0;
						// for (int j=0; j<90; j++)
						//{
						for (int x=0; x<numberOfTurbines; x++)
						{
							randomInteger = (rand()%100)+1;
							if (randomInteger < HelpMaintenanceProbability[i] )
							{
								NumberOfMaintenanceTask ++ ;
							}
						}	
						//}
						ActNum[f][i][p][s] = NumberOfMaintenanceTask;
					}
				}
			}
		}
	}



	//MainTime
	for (int f=0; f<fFarms; f++)
	{
		for (int i=0; i<iActivity; i++)
		{
			for (int p=0; p<pPeriods; p++)
			{
				for (int v=0; v<vVessels; v++)
				{
					MainTime[f][i][p][v]=HelpTimeFV[f%10][v]+HelpTimeIV[i][v];
				}
			}
		}
	}
	
	for ( int p=1; p<pPeriods; p++)
	{
		for (int v=0; v<vVessels; v++)
		{
			InvCostV[p][v] = InvCostV[p-1][v]*(1-rate);
		}
	}

	for ( int p=1; p<pPeriods; p++)
	{
		for (int v=0; v<vVessels; v++)
		{
			SelRevenue[p][v] = SelRevenue[p-1][v]*(1-rate);
		}
	}

	//Residual Value
	for (int v=0; v<vVessels; v++)
	{
		ResValue[v] = SelRevenue[pPeriods-1][v];
	}

	for ( int p=1; p<pPeriods; p++)
	{
		for (int w=0; w<wOffshore; w++)
		{
			InvCostW[p][w] = InvCostW[p-1][w]*(1-rate);
		}
	}

	for ( int p=1; p<pPeriods; p++)
	{
		for (int v=0; v<vVessels; v++)
		{
			FixCostV[p][v] = FixCostV[p-1][v]*(1-rate);
		}
	}

	for ( int p=1; p<pPeriods; p++)
	{
		for (int w=0; w<wOffshore; w++)
		{
			FixCostW[p][w] = FixCostW[p-1][w]*(1-rate);
		}
	}

	for ( int p=1; p<pPeriods; p++)
	{
		for (int v=0; v<vVessels; v++)
		{
			VarCost[p][v] = VarCost[p-1][v]*(1-rate);
		}
	}

	int helpScenario = sScenario;
	for (int s =0; s<sScenario; s++)
	{
		Probability[s]= (1.00/helpScenario);
	}


	// Rent cost with season variation
	// Period 0 and 3 is winter, period 1 and 2 is summer
	// Rent cost is higher in summer
	int ppp;
	for ( int p=1; p<pPeriods; p++)
	{
		ppp=p%4;
		for (int v=0; v<vVessels; v++)
		{
			if (ppp==0 || ppp==3)
			{
				RentCost[p][v] = RentCost[0][v]*pow((1-rate),p);
			}
			else
				RentCost[p][v] = 2*RentCost[0][v]*pow((1-rate),p);
		}
	}

	// Hire revenue is lower in winter
	for ( int p=1; p<pPeriods; p++)
	{
		ppp=p%4;
		for (int v=0; v<vVessels; v++)
		{
			if (ppp==0 || ppp==3)
			{
				HireRevenue[p][v] = 0.5*HireRevenue[0][v]*pow((1-rate),p);
			}
			else
				HireRevenue[p][v] = HireRevenue[0][v]*pow((1-rate),p);
		}
	}

	for ( int p=1; p<pPeriods; p++)
	{
			Budget[p] = Budget[p-1]*(1+rate);
	}

	outStream << "InvCostV : [ " << endl;
	for (int p=0; p<pPeriods; p++)
	{
		for (int v=0; v<vVessels; v++)
		{
		outStream << InvCostV[p][v] << "	 ";
		}
		outStream << endl;
	}
	outStream << "]" << endl << endl;

	outStream << "SelRevenue : [ " << endl;
	for (int p=0; p<pPeriods; p++)
	{
		for (int v=0; v<vVessels; v++)
		{
		outStream << SelRevenue[p][v] << "	  ";
		}
		outStream << endl;
	}
	outStream << "]" << endl << endl;


	outStream << "InvCostW : [ " << endl;
	for (int p=0; p<pPeriods; p++)
	{
		for (int w=0; w<wOffshore; w++)
		{
		outStream << InvCostW[p][w] << "	 ";
		}
		outStream << endl;
	}
	outStream << "]" << endl << endl;

	outStream << "FixCostV : [ " << endl;
	for (int p=0; p<pPeriods; p++)
	{
		for (int v=0; v<vVessels; v++)
		{
		outStream << FixCostV[p][v] << "	";
		}
		outStream << endl;
	}
	outStream << "]" << endl << endl;

	outStream << "FixCostW : [ " << endl;
	for (int p=0; p<pPeriods; p++)
	{
		for (int w=0; w<wOffshore; w++)
		{
		outStream << FixCostW[p][w] << "	  ";
		}
		outStream << endl;
	}
	outStream << "]" << endl << endl;

	outStream << "VarCost : [ " << endl;
	for (int p=0; p<pPeriods; p++)
	{
		for (int v=0; v<vVessels; v++)
		{
		outStream << VarCost[p][v] << "		 ";
		}
		outStream << endl;
	}
	outStream << "]" << endl << endl;

	outStream << "RentCost : [ " << endl;
	for (int p=0; p<pPeriods; p++)
	{
		for (int v=0; v<vVessels; v++)
		{
		outStream << RentCost[p][v] << "	 ";
		}
		outStream << endl;
	}
	outStream << "]" << endl << endl;

	outStream << "HireRevenue : [ " << endl;
	for (int p=0; p<pPeriods; p++)
	{
		for (int v=0; v<vVessels; v++)
		{
		outStream << HireRevenue[p][v] << "		 ";
		}
		outStream << endl;
	}
	outStream << "]" << endl << endl;

	outStream << "Budget : [ " << endl;
	for (int p=0; p<pPeriods; p++)
	{
		outStream << Budget[p] << "		";
	}
	outStream << endl << "]" << endl << endl;

	outStream << "MaxCap : [ " <<endl;
	for (int w=0; w<wOffshore; w++)
	{
		outStream << MaxCap[w] << "		";
	}
	outStream << endl << "]" << endl << endl;


	outStream << "AmCap : [ " << endl;
	for (int v=0; v<vVessels; v++)
	{
		for (int w=0; w<wOffshore; w++)
		{
		outStream << AmCap[v][w] << "	  ";
		}
		outStream << endl;
	}
	outStream << "]" << endl << endl;

	outStream << "MaxLim : [ " <<endl;
	for (int k=0; k<kLineSegment; k++)
	{
		outStream << MaxLim[k] << "		";
	}
	outStream << endl << "]" << endl << endl;

	outStream << "OpTime : [ " <<endl;
	for (int p=0; p<pPeriods; p++)
	{
		for (int v=0; v<vVessels; v++)
		{
			for (int s=0; s<sScenario; s++)
			{
				outStream << OpTime[p][v][s] << "	 ";
			}
			outStream << endl;
		}
		outStream << endl;
	}
	outStream << "]" << endl << endl;

	outStream << "DownCost : [ " << endl;
	for (int f=0; f<fFarms; f++)
	{
		for (int i=0; i<iActivity; i++)
		{
			for (int k=0; k<kLineSegment; k++)
			{
				for (int p=0; p<pPeriods; p++)
				{
					outStream << DownCost[f][i][k][p] << "	";
				}
				outStream << endl;
			}
			outStream << endl;
		}
		outStream << endl;
	}
	outStream << "]" << endl << endl;

	outStream << "ActNum : [ " << endl;
	for (int f=0; f<fFarms; f++)
	{
		for (int i=0; i<iActivity; i++)
		{
				for (int p=0; p<pPeriods; p++)
				{
					for (int s=0; s<sScenario; s++)
					{
						outStream << ActNum[f][i][p][s] << "	";
					}
					outStream << endl;
				}
				outStream << endl;
		}
		outStream << endl;
	}
	outStream << "]" << endl << endl;

	outStream << "MainTime : [ " << endl;
	for (int f=0; f<fFarms; f++)
	{
		for (int i=0; i<iActivity; i++)
		{
			for (int p=0; p<pPeriods; p++)
			{
				for (int v=0; v<vVessels; v++)
				{
					outStream << MainTime[f][i][p][v] << "	";
				}
				outStream << endl;
			}
			outStream << endl;
		}
		outStream << endl;
	}
	outStream << "]" << endl << endl;

	outStream << "ResValue : [ " <<endl;
		for (int v=0; v<vVessels; v++)
		{
			outStream << ResValue[v] << "	 ";
		}
	outStream << "]" << endl << endl;

	outStream << "Probability : [ " <<endl;
	for (int s=0; s<sScenario; s++)
	{
		outStream << Probability[s] << "	";
	}
	outStream <<"]" << endl << endl;
	
	inTime.close();
	inEl.close();
	inTimeIV.close();
	inTimeFV.close();
	inNumber.close();
	inInvCostV.close();
	inInvCostW.close();
	inFixCostV.close();
	inFixCostW.close();
	inVarCost.close();
	inRentCost.close();
	outStream.close();

	std::cout << "Press ENTER to continue...";
	std::cin.ignore( std::numeric_limits<std::streamsize>::max(), '\n' );

	return 0;
}

//void writePV(double PVarray[pPeriods][vVessels])
//{
//	ofstream outStream;
//	outStream.open("outfile.txt");
//	for (int p=0; p<pPeriods; p++)
//	{
//		for (int v=0; v<vVessels; v++)
//		{
//		outStream << PVarray[p][v] << "  ";
//		}
//		outStream << endl;
//	}
//	outStream << "]" << endl << endl;
//}
